/*   `Deep Thought', a softcore CPU implemented on a FPGA

    Copyright (C) 2010 Markus Hofstaetter <markus.manrow@gmx.at>
    Copyright (C) 2010 Martin Perner <e0725782@student.tuwien.ac.at>
    Copyright (C) 2010 Stefan Rebernig <stefan.rebernig@gmail.com>
    Copyright (C) 2010 Manfred Schwarz <e0725898@student.tuwien.ac.at>
    Copyright (C) 2010 Bernhard Urban <lewurm@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef COLOR_H
#define COLOR_H

//
//taken from
//http://www.velocityreviews.com/forums/t279115-design-question-a-little-c-header-for-colorizing-text-in-linux-comments-ideas.html

#include <iostream>
using namespace std;

enum ColorName
{
	black,
	red,
	green,
	brown,
	blue,
	magenta,
	cyan,
	gray,

	darkgray,
	lightred,
	lightgreen,
	yellow,
	lightblue,
	lightmagenta,
	lightcyan,
	white
};


struct color
{
	color(ColorName f = white, ColorName b = black) : fore(f), back(b) {}

	ColorName fore;
	ColorName back;
};


inline ostream& operator<<(ostream& o, const color& c)
{
	//reset, just to be sure
	o << "\033[0m";

	o << "\033[";

	if(c.back != black) {
		o << "4" << c.back << ";";
	}
	else {
		o << "0;";
	}

	if(c.fore > gray) {
		// bold color
		o << "1;3" << c.fore - gray - 1;
	}
	else {
		o << "0;3" << c.fore ;
	}

	return o << "m";

}

#endif
