/*   `Deep Thought', a softcore CPU implemented on a FPGA

    Copyright (C) 2010 Markus Hofstaetter <markus.manrow@gmx.at>
    Copyright (C) 2010 Martin Perner <e0725782@student.tuwien.ac.at>
    Copyright (C) 2010 Stefan Rebernig <stefan.rebernig@gmail.com>
    Copyright (C) 2010 Manfred Schwarz <e0725898@student.tuwien.ac.at>
    Copyright (C) 2010 Bernhard Urban <lewurm@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */


//i'm sorry
//pervert forwarding
//didn't know (or was to lazy) to find another fix
#define __CPU__H__
class CCpu;

#include "cpmem.hpp"

using namespace std;

template <typename T>
void CPMem<T>::set(const MEMORY_ADDRESS address, const T data)
{
	if(address >= MAX_MEMORY) {
		stringstream error;
		error << "memoryaddress " << address << " out of range";
		throw out_of_range(error.str());
	}

	MEMORY_ADDRESS temp = (address & (~(BYTE_COUNT-1))) / BYTE_COUNT;
	auto iter = m_memory.begin();
	while(temp > 0) {
		++iter;
		temp--;
	}

	iter = m_memory.insert(iter, data);
	++iter;
	m_memory.erase(iter);
}

template <typename T>
T CPMem<T>::get(const MEMORY_ADDRESS address) const
{
	if(address >= MAX_MEMORY) {
		stringstream error;
		error << "memoryaddress " << address << " out of range";
		throw out_of_range(error.str());
	}
	MEMORY_ADDRESS temp = (address & (~(BYTE_COUNT-1))) / BYTE_COUNT;
	return m_memory[temp];
}

template <typename T>
CPMem<T>::~CPMem()
{
	for(auto iter = m_memory.begin(); iter != m_memory.end(); ++iter) {
		delete (*iter);
	}
}


template class CPMem<Iinstr*>;
