/*   `Deep Thought', a softcore CPU implemented on a FPGA

    Copyright (C) 2010 Markus Hofstaetter <markus.manrow@gmx.at>
    Copyright (C) 2010 Martin Perner <e0725782@student.tuwien.ac.at>
    Copyright (C) 2010 Stefan Rebernig <stefan.rebernig@gmail.com>
    Copyright (C) 2010 Manfred Schwarz <e0725898@student.tuwien.ac.at>
    Copyright (C) 2010 Bernhard Urban <lewurm@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef __IEXT_I_
#define __IEXT_I_

class CCpu;

#include "ccpu.hpp"

class disasm;

#include "disasm.h"


class Iext {
	public:
		static void setCPU(CCpu* cpu) {m_cpu = cpu;}
		static void setDisasm(disasm* dasm) { m_disasm = dasm; }

		virtual ~Iext() {}
		//called by cpu before every tick
		virtual void applyTick() = 0;
		virtual void parseInput(const vector<string>& in) = 0;
		virtual void loadData(const int address, CDat value) = 0;
		virtual CDat readData(const int address) = 0;
		static CCpu* m_cpu;
		static disasm* m_disasm;
};

#endif
