--   `Deep Thought', a softcore CPU implemented on a FPGA
--
--  Copyright (C) 2010 Markus Hofstaetter <markus.manrow@gmx.at>
--  Copyright (C) 2010 Martin Perner <e0725782@student.tuwien.ac.at>
--  Copyright (C) 2010 Stefan Rebernig <stefan.rebernig@gmail.com>
--  Copyright (C) 2010 Manfred Schwarz <e0725898@student.tuwien.ac.at>
--  Copyright (C) 2010 Bernhard Urban <lewurm@gmail.com>
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program.  If not, see <http://www.gnu.org/licenses/>.

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

use work.common_pkg.all;
use work.extension_pkg.all;
--use work.alu_pkg.all;
--use work.gpm_pkg.all;

entity extension_gpm is

	generic	(
			-- active reset value
			RESET_VALUE : std_logic
			);
	port(
		--System inputs
			clk :   in std_logic;
			reset : in std_logic;
		-- general extension interface			
			ext_reg  : in extmod_rec;
			 data_out : out gp_register_t;
		-- Input
			psw_nxt : in status_rec;
			paddr 	: in paddr_t;
			pinc	: in std_logic;
			pwr_en  : in std_logic;
		-- Ouput
			 psw     : out status_rec;
			 pval	 : out gp_register_t;
			 pval_nxt : out gp_register_t
		);
		
end extension_gpm;
